/*
Пример использования
Получение списка доступных образов
*/
#Расскомментируйте этот код,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером

# terraform {
#   required_providers {
#     decort = {
#       version = "<VERSION>"
#       source  = "basis/decort/decort"
#     }
#   }
# }


provider "decort" {
  authenticator = "decs3o"
  #controller_url = <DECORT_CONTROLLER_URL>
  controller_url = "https://ds1.digitalenergy.online"
  #oauth2_url = <DECORT_SSO_URL>
  oauth2_url           = "https://sso.digitalenergy.online"
  allow_unverified_ssl = true
}

resource "decort_cb_extnet" "new_extnet" {
  # Наименование внешней сети
  # Обязательный параметр
  # Тип - строка
  name = "test_extnet"

  # ID платформы
  # Обязательный параметр
  # Тип - число
  gid = 500

  # CIDR
  # Обязательный параметр
  # Тип - строка
  ipcidr = "192.168.0.0/24"

  # ID виртуальной локальной сети
  # Обязательный параметр
  # Тип - число
  vlan_id = 111

  # IP-адрес шлюза внешней сети
  # Опциональный параметр
  # Тип - строка
  gateway = "test desc"

  # Список DNS адресов
  # Опциональный параметр
  # Тип - массив строк
  dns = ["8.8.8.8", "9.9.9.9"]

  # Список NTP адресов
  # Опциональный параметр
  # Тип - массив строк
  ntp = ["ntp0.ntp-servers.net", "ntp1.ntp-servers.net"]

  # IP-адреса для проверки доступности сети
  # Опциональный параметр
  # Тип - массив строк
  check_ips = ["191.255.0.0,", "191.255.0.0,"]

  # Если true - DHCP-сервер создан не будет
  # Опциональный параметр
  # Тип - булевое
  virtual = true

  # Описание
  # Опциональный параметр
  # Тип - строка
  desc = "test desc"

  # Начало диапазона IP-адресов
  # Опциональный параметр
  # Тип - строка
  start_ip = "191.255.0.0"

  # Окончание диапазона IP-адресов
  # Опциональный параметр
  # Тип - строка
  end_ip = "191.255.0.40"

  # IP с которым будет создан vnfdev
  # Опциональный параметр
  # Тип - строка
  vnfdev_ip = "191.255.0.20"

  # Количество предварительно созданных бронирований
  # Опциональный параметр
  # Тип - число
  # По-умолчанию значение 128
  pre_reservations_num = 128
 
  # Имя bridge Openvswitch для подключения к внешней сети
  # Опциональный параметр
  # Тип - строка
  ovs_bridge = "some"

  # Включение/Выключение внешней сети
  # Опциональный параметр 
  # Тип - булев
  enable = true

  # Сделать сеть сетью по умолчанию
  # Опциональный параметр 
  # Тип - булев
  set_default = true

  # Список исключенных IP адресов
  # Опциональный параметр
  # Тип - массив строк
  excluded_ips = ["192.168.0.4", "192.168.0.5"]

  # Диапазон исключенных IP адресов
  # Опциональный параметр
  excluded_ips_range {
  # Начало диапазона
  # Обязательный параметр
  # Тип - строка
  ip_start = "192.168.0.4"

  # Окончание диапазона
  # Обязательный параметр
  # Тип - строка
  ip_end = "192.168.0.50"
  }
 
  # Список id аккаунтов, которым предоставлен доступ к extnet
  # Опциональный параметр
  # Тип - массив чисел
  shared_with = [112, 123]
  
  # Изменение настроек ограничения трафика сети
  # Значение по умолчанию 0, то есть без ограничений
  # Опциональный параметр
  default_qos {
  # Ограничение внутреннего трафика в кбит
  # Опциональный параметр
  # Тип - число
  in_rate = 0

  # Ограничение внутреннего burst трафика в кбит
  # Опциональный параметр
  # Тип - число
  in_burst = 0

  # Ограничение внешнего трафика в кбит
  # Опциональный параметр
  # Тип - число
  e_rate = 0
  }

  # ID stack на который происходит миграция
  # Опциональный параметр
  # Тип - число
  migrate = 1 

  # Перезапустить сеть
  # Опциональный параметр 
  # Тип - булев
  restart = true
}

output "extnet" {
  value = decort_cb_extnet.new_extnet
}