/*
Пример использования
Ресурса vins
Ресурс позволяет:
1. Создавать vins
2. Удалять vins
3. Восстанвливать vins
4. Добавлять и убирать подключение к внешней сети
5. Резервировать и освобождать ip для vins
6. Добавлять и удалять natrule
7. Перезапускать и редеплоить vnfdev

*/

#Расскомментируйте этот код,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером
/*
terraform {
  required_providers {
    decort = {
      version = "<VERSION>"
      source  = "basis/decort/decort"
    }
  }
}
*/

provider "decort" {
  authenticator = "decs3o"
  #controller_url = <DECORT_CONTROLLER_URL>
  controller_url = "https://mr4.digitalenergy.online"
  #oauth2_url = <DECORT_SSO_URL>
  oauth2_url           = "https://sso.digitalenergy.online"
  allow_unverified_ssl = true
}

resource "decort_cb_vins" "vins" {
  # Параметры для создания vins

  #обязательный параметр
  #имя создаваемого ресурса
  #тип - строка
  name = "Test_name"

  #опциональный параметр
  #id аккаунта для создаения ресурса
  #тип - число
  #внимание, для создания ресурса обязательно должен быть указан или rg_id, или account_id
  account_id = 2023

  #опциональный параметр
  #id ресурсной группы для создаения ресурса
  #тип - число
  #внимание, для создания ресурса обязательно должен быть указан или rg_id, или account_id
  rg_id = 10101

  #опциональный параметр
  #id внешней сети для подключения к ней ресурса
  #тип - число
  #ext_net_id  = 2222

  #опциональный параметр
  #ip внешней сети для подключения к нему ресурса
  #тип - строка
  #ext_ip = "1.1.1.1"

  #опциональный параметр
  #private network IP CIDR
  #тип - строка
  #ipcidr      = "192.168.0.1"

  #опциональный параметр
  #количество зарезервированных адресов на момент создания
  #тип - число
  #значение по умолчанию 32
  #pre_reservations_num = 2

  #опциональный параметр
  #grid (platform) ID
  #тип - число
  #gid                  = 2002

  #опциональный параметр
  #Description
  #тип - строка
  #description = "Description"

  #опциональный параметр
  #Причина запроса
  #тип - строка
  #reason = "test"

  #опциональный параметр
  #блок для указания списка routes
  #тип - блок
  #routes = [{
    #опциональный параметр
    #destination network
    #тип - строка
    #destination     = "DHCP"

    #опциональный параметр
    #destination network mask in 255.255.255.255 format
    #тип - строка
    #netmask  = "192.168.5.5"

    #опциональный параметр
    #next hop host, IP address from ViNS ID free IP pool
    #тип - строка
    #gateway = "192.168.5.5"
  #}]

  # Default qos

  #опциональный параметр
  #блок для указания default_qos
  #тип - блок
  #default_qos = {
    #опциональный параметр
    #ingress rate
    #тип - число
    #in_rate = 1

    #опциональный параметр
    #ingress burst
    #тип - число
    #in_burst = 1

    #опциональный параметр
    #egress rate
    #тип - число
    #e_rate = 1
  #}

  # Enable, delete parameters

  #опциональный параметр
  #ручное подключение и отключение ресурса
  #тип - булев тип
  #enable               = true

  #опциональный параметр
  #удаление навсегда
  #тип - булев тип
  #permanently          = true

  #опциональный параметр
  #удаляет за собой все зависимые ресурсы
  #тип - булев тип
  #force                = true

  # IP release, IP reserve parameters

  #опциональный параметр
  #блок для резервирования ip
  #тип - блок
  #ip {
    #обязательный параметр
    #тип подключения
    #тип - строка
    # type     = "DHCP"

    #опциональный параметр
    #ip который необходимо зарезервировать
    #тип - строка
    #ip_addr  = "192.168.5.5"

    #опциональный параметр
    #mac который необходимо зарезервировать
    #тип - строка
    #mac = "ff:ff:ff:ff:ff:ff"

    #опциональный параметр
    #compute_id, ассоциируемый с типом DHCP
    #тип - число
    #compute_id = 1234

    #опциональный параметр
    #причина запроса
    #тип - строка
    #reason = "one more reason"
  #}

  # Добавление и удаление NAT Rules

  #опциональный параметр
  #блок для добавления natRule
  #тип - блок
  #nat_rule {
    #обязательный параметр
    #ip внутренний
    #тип - строка
    # int_ip         = "192.168.0.28"

    #обязательный параметр
    #внутренний порт
    #тип - число
    # int_port       = 80

    #обязательный параметр
    #начало диапазона внешних портов
    #тип - число
    # ext_port_start = 8001

    #опциональный параметр
    #конец диапазона внешних портов
    #тип - число
    #ext_port_end   = 8001

    #опциональный параметр
    #протокол natRule: разрешенные значения "tcp", "udp"
    #тип - строка
    #proto          = "tcp"
  #}

  # vnf dev start, stop, restart, reset, redeploy parameters

  #опциональный параметр
  #true: старт vnfDev; false: стоп vnfDev
  #тип - булев тип
  #vnfdev_start = true

  #опциональный параметр
  #перезапуск vnfDev
  #тип - булев тип
  #vnfdev_restart  = true

  #опциональный параметр
  #ресет vnfDev
  #тип - булев тип
  #vnfdev_reset  = true

  #опциональный параметр
  #редеплой vnfDev
  #тип - булев тип
  #vnfdev_redeploy = true
}

output "test" {
  value = decort_cb_vins.vins
}
